diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/channel-access-manager.cc ns-3.45/src/wifi/model/channel-access-manager.cc
--- ns-3.44/src/wifi/model/channel-access-manager.cc	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/channel-access-manager.cc	2025-06-01 20:34:45.612702100 -0700
@@ -29,6 +29,8 @@
 
 NS_OBJECT_ENSURE_REGISTERED(ChannelAccessManager);
 
+const Time ChannelAccessManager::DEFAULT_N_SLOTS_LEFT_MIN_DELAY = MicroSeconds(25);
+
 /**
  * Listener for PHY events. Forwards to ChannelAccessManager.
  * The ChannelAccessManager may handle multiple PHY listeners connected to distinct PHYs,
@@ -88,11 +90,11 @@
         }
     }
 
-    void NotifyRxEndError() override
+    void NotifyRxEndError(const WifiTxVector& txVector) override
     {
         if (m_active)
         {
-            m_cam->NotifyRxEndErrorNow();
+            m_cam->NotifyRxEndErrorNow(txVector);
         }
     }
 
@@ -186,17 +188,30 @@
                           BooleanValue(false),
                           MakeBooleanAccessor(&ChannelAccessManager::m_proactiveBackoff),
                           MakeBooleanChecker())
+            .AddAttribute("ResetBackoffThreshold",
+                          "If no PHY operates on this link for a period greater than this "
+                          "threshold, all the backoffs are reset.",
+                          TimeValue(Time{0}),
+                          MakeTimeAccessor(&ChannelAccessManager::m_resetBackoffThreshold),
+                          MakeTimeChecker())
             .AddAttribute("NSlotsLeft",
-                          "Fire the NSlotsLeftAlert trace source when the backoff counter with "
-                          "the minimum value among all ACs reaches this value or it is started "
-                          "with a value less than this attribute. If this value is zero, the "
-                          "trace source is never fired.",
+                          "The NSlotsLeftAlert trace source is fired when the number of remaining "
+                          "backoff slots for any AC is equal to or less than the value of this "
+                          "attribute. Note that the trace source is fired only if the AC for which "
+                          "the previous condition is met has requested channel access. Also, if "
+                          "the value of this attribute is zero, the trace source is never fired.",
                           UintegerValue(0),
                           MakeUintegerAccessor(&ChannelAccessManager::m_nSlotsLeft),
                           MakeUintegerChecker<uint8_t>())
+            .AddAttribute("NSlotsLeftMinDelay",
+                          "The minimum gap between the end of a medium busy event and the time "
+                          "the NSlotsLeftAlert trace source can be fired.",
+                          TimeValue(ChannelAccessManager::DEFAULT_N_SLOTS_LEFT_MIN_DELAY),
+                          MakeTimeAccessor(&ChannelAccessManager::m_nSlotsLeftMinDelay),
+                          MakeTimeChecker())
             .AddTraceSource("NSlotsLeftAlert",
-                            "The backoff counter of the AC with the given index reached the "
-                            "threshold set through the NSlotsLeft attribute.",
+                            "The number of remaining backoff slots for the AC with the given index "
+                            "reached the threshold set through the NSlotsLeft attribute.",
                             MakeTraceSourceAccessor(&ChannelAccessManager::m_nSlotsLeftCallback),
                             "ns3::ChannelAccessManager::NSlotsLeftCallback");
     return tid;
@@ -210,8 +225,8 @@
       m_lastRxReceivedOk(true),
       m_lastTxEnd(0),
       m_lastSwitchingEnd(0),
-      m_sleeping(false),
-      m_off(false),
+      m_lastSleepEnd(0),
+      m_lastOffEnd(0),
       m_linkId(0)
 {
     NS_LOG_FUNCTION(this);
@@ -259,6 +274,7 @@
 {
     NS_LOG_FUNCTION(this << phy);
 
+    const auto now = Simulator::Now();
     auto phyListener = GetPhyListener(phy);
 
     if (phyListener)
@@ -272,21 +288,32 @@
         // channel access manager; unregister the listener and register again (below) to get
         // updated CCA busy information
         phy->UnregisterListener(phyListener);
+        // we expect that the PHY is reconnected immediately after the other PHY left the link:
+        // reset the start of m_lastNoPhy so as to ignore this event
+        NS_ASSERT(m_lastNoPhy.start == now);
+        NS_ASSERT(m_lastNoPhy.end <= m_lastNoPhy.start);
+        m_lastNoPhy.start = m_lastNoPhy.end;
     }
     else
     {
         phyListener = std::make_shared<PhyListener>(this);
         m_phyListeners.emplace(phy, phyListener);
-        if (!m_phy)
+        if (m_phy)
+        {
+            DeactivatePhyListener(m_phy);
+        }
+        else
         {
             // no PHY operating on this link and no previous PHY listener to reactivate
-            m_lastSwitchingEnd = Simulator::Now();
+            m_lastSwitchingEnd = now;
+            m_lastNoPhy.end = now;
+            if (now - m_lastNoPhy.start > m_resetBackoffThreshold)
+            {
+                ResetAllBackoffs();
+            }
         }
     }
-    if (m_phy)
-    {
-        DeactivatePhyListener(m_phy);
-    }
+
     m_phy = phy; // this is the new active PHY
     ResizeLastBusyStructs();
     phy->RegisterListener(phyListener);
@@ -303,7 +330,10 @@
         // reset m_phy if we are removing listener registered for the active PHY
         if (m_phy == phy)
         {
+            UpdateBackoff();
+            UpdateLastIdlePeriod();
             m_phy = nullptr;
+            m_lastNoPhy.start = Simulator::Now();
         }
     }
 }
@@ -316,10 +346,6 @@
     {
         listener->SetActive(false);
     }
-    if (m_phy == phy)
-    {
-        m_phy = nullptr;
-    }
 }
 
 void
@@ -351,19 +377,27 @@
 Time
 ChannelAccessManager::GetSlot() const
 {
-    return m_phy->GetSlot();
+    if (m_phy)
+    {
+        m_cachedSlot = m_phy->GetSlot();
+    }
+    return m_cachedSlot;
 }
 
 Time
 ChannelAccessManager::GetSifs() const
 {
-    return m_phy->GetSifs();
+    if (m_phy)
+    {
+        m_cachedSifs = m_phy->GetSifs();
+    }
+    return m_cachedSifs;
 }
 
 Time
 ChannelAccessManager::GetEifsNoDifs() const
 {
-    return m_phy->GetSifs() + m_phy->GetAckTxTime();
+    return m_eifsNoDifs;
 }
 
 void
@@ -426,6 +460,17 @@
         m_lastIdle.erase(WIFI_CHANLIST_SECONDARY80);
     }
 
+    if (width >= MHz_u{320})
+    {
+        m_lastBusyEnd.emplace(WIFI_CHANLIST_SECONDARY160, now);
+        m_lastIdle.emplace(WIFI_CHANLIST_SECONDARY160, Timespan{now, now});
+    }
+    else
+    {
+        m_lastBusyEnd.erase(WIFI_CHANLIST_SECONDARY160);
+        m_lastIdle.erase(WIFI_CHANLIST_SECONDARY160);
+    }
+
     // TODO Add conditions for new channel widths as they get supported
 }
 
@@ -476,7 +521,7 @@
 
     // No backoff needed if in sleep mode or off. Checking if m_phy is nullptr is a workaround
     // needed for EMLSR and may be removed in the future
-    if (m_sleeping || m_off || !m_phy)
+    if (!m_phy || m_phy->IsStateSleep() || m_phy->IsStateOff())
     {
         return false;
     }
@@ -537,7 +582,7 @@
     }
     // Deny access if in sleep mode or off. Checking if m_phy is nullptr is a workaround
     // needed for EMLSR and may be removed in the future
-    if (m_sleeping || m_off || !m_phy)
+    if (!m_phy || m_phy->IsStateSleep() || m_phy->IsStateOff())
     {
         return;
     }
@@ -651,39 +696,74 @@
 ChannelAccessManager::AccessTimeout()
 {
     NS_LOG_FUNCTION(this);
+
+    if (!m_phy && Simulator::Now() - m_lastNoPhy.start > m_resetBackoffThreshold)
+    {
+        ResetAllBackoffs();
+        return;
+    }
+
     UpdateBackoff();
     DoGrantDcfAccess();
     DoRestartAccessTimeoutIfNeeded();
 }
 
-Time
-ChannelAccessManager::GetAccessGrantStart(bool ignoreNav) const
+std::multimap<Time, WifiExpectedAccessReason>
+ChannelAccessManager::DoGetAccessGrantStart(bool ignoreNav) const
 {
     NS_LOG_FUNCTION(this << ignoreNav);
+    const auto now = Simulator::Now();
+
+    std::multimap<Time, WifiExpectedAccessReason> ret;
+
+    // an EDCA TXOP is obtained based solely on activity of the primary channel
+    // (Sec. 10.23.2.5 of IEEE 802.11-2020)
+    const auto busyAccessStart = m_lastBusyEnd.at(WIFI_CHANLIST_PRIMARY);
+    ret.emplace(busyAccessStart, WifiExpectedAccessReason::BUSY_END);
+
     auto rxAccessStart = m_lastRx.end;
-    if ((m_lastRx.end <= Simulator::Now()) && !m_lastRxReceivedOk)
+    if ((m_lastRx.end <= now) && !m_lastRxReceivedOk)
     {
         rxAccessStart += GetEifsNoDifs();
     }
-    // an EDCA TXOP is obtained based solely on activity of the primary channel
-    // (Sec. 10.23.2.5 of IEEE 802.11-2020)
-    const auto busyAccessStart = m_lastBusyEnd.at(WIFI_CHANLIST_PRIMARY);
+    ret.emplace(rxAccessStart, WifiExpectedAccessReason::RX_END);
+
+    ret.emplace(m_lastTxEnd, WifiExpectedAccessReason::TX_END);
+
     const auto navAccessStart = ignoreNav ? Time{0} : m_lastNavEnd;
+    ret.emplace(navAccessStart, WifiExpectedAccessReason::NAV_END);
+
+    ret.emplace(m_lastAckTimeoutEnd, WifiExpectedAccessReason::ACK_TIMER_END);
+    ret.emplace(m_lastCtsTimeoutEnd, WifiExpectedAccessReason::CTS_TIMER_END);
+    ret.emplace(m_lastSwitchingEnd, WifiExpectedAccessReason::SWITCHING_END);
+
+    const auto noPhyStart = m_phy ? m_lastNoPhy.end : now;
+    ret.emplace(noPhyStart, WifiExpectedAccessReason::NO_PHY_END);
+
+    ret.emplace(m_lastSleepEnd, WifiExpectedAccessReason::SLEEP_END);
+    ret.emplace(m_lastOffEnd, WifiExpectedAccessReason::OFF_END);
+
+    NS_LOG_INFO("rx access start=" << rxAccessStart.As(Time::US)
+                                   << ", busy access start=" << busyAccessStart.As(Time::US)
+                                   << ", tx access start=" << m_lastTxEnd.As(Time::US)
+                                   << ", nav access start=" << navAccessStart.As(Time::US)
+                                   << ", switching access start=" << m_lastSwitchingEnd.As(Time::US)
+                                   << ", no PHY start=" << noPhyStart.As(Time::US)
+                                   << ", sleep access start=" << m_lastSleepEnd.As(Time::US)
+                                   << ", off access start=" << m_lastOffEnd.As(Time::US));
+    return ret;
+}
+
+Time
+ChannelAccessManager::GetAccessGrantStart(bool ignoreNav) const
+{
+    NS_LOG_FUNCTION(this << ignoreNav);
+
+    auto timeReasonMap = DoGetAccessGrantStart(ignoreNav);
+    NS_ASSERT(!timeReasonMap.empty());
+    const auto accessGrantedStart = timeReasonMap.crbegin()->first;
+    NS_LOG_INFO("access grant start=" << accessGrantedStart.As(Time::US));
 
-    const auto accessGrantedStart = std::max({rxAccessStart,
-                                              busyAccessStart,
-                                              m_lastTxEnd,
-                                              navAccessStart,
-                                              m_lastAckTimeoutEnd,
-                                              m_lastCtsTimeoutEnd,
-                                              m_lastSwitchingEnd});
-
-    NS_LOG_INFO("access grant start="
-                << accessGrantedStart.As(Time::US)
-                << ", rx access start=" << rxAccessStart.As(Time::US) << ", busy access start="
-                << busyAccessStart.As(Time::US) << ", tx access start=" << m_lastTxEnd.As(Time::US)
-                << ", nav access start=" << navAccessStart.As(Time::US)
-                << ", switching access start=" << m_lastSwitchingEnd.As(Time::US));
     return accessGrantedStart + GetSifs();
 }
 
@@ -724,6 +804,70 @@
     return backoffEnd;
 }
 
+WifiExpectedAccessReason
+ChannelAccessManager::GetExpectedAccessWithin(const Time& delay) const
+{
+    NS_LOG_FUNCTION(this << delay.As(Time::US));
+
+    const auto now = Simulator::Now();
+    const auto deadline = now + delay;
+    const auto timeReasonMap = DoGetAccessGrantStart(false);
+    NS_ASSERT(!timeReasonMap.empty());
+    auto accessGrantStart = timeReasonMap.crbegin()->first;
+
+    if (accessGrantStart >= deadline)
+    {
+        // return the earliest reason for which access cannot be granted in time
+        for (const auto& [time, reason] : timeReasonMap)
+        {
+            if (time >= deadline)
+            {
+                NS_ASSERT(reason != WifiExpectedAccessReason::ACCESS_EXPECTED);
+                NS_ASSERT(reason != WifiExpectedAccessReason::NOTHING_TO_TX);
+                NS_ASSERT(reason != WifiExpectedAccessReason::NOT_REQUESTED);
+                NS_ASSERT(reason != WifiExpectedAccessReason::BACKOFF_END);
+                NS_LOG_DEBUG("Access grant start (" << accessGrantStart.As(Time::US)
+                                                    << ") too late for reason " << reason);
+                return reason;
+            }
+        }
+        NS_ABORT_MSG("No reason found that exceeds the deadline!");
+    }
+
+    accessGrantStart += GetSifs();
+    auto reason = WifiExpectedAccessReason::NOT_REQUESTED;
+
+    for (auto txop : m_txops)
+    {
+        if (txop->GetAccessStatus(m_linkId) != Txop::REQUESTED)
+        {
+            continue;
+        }
+
+        if (!txop->HasFramesToTransmit(m_linkId))
+        {
+            if (reason != WifiExpectedAccessReason::BACKOFF_END)
+            {
+                reason = WifiExpectedAccessReason::NOTHING_TO_TX;
+            }
+            continue;
+        }
+
+        reason = WifiExpectedAccessReason::BACKOFF_END;
+        const auto backoffEnd = GetBackoffEndFor(txop, accessGrantStart);
+
+        if (backoffEnd >= now && backoffEnd <= deadline)
+        {
+            NS_LOG_DEBUG("Backoff end for " << txop->GetWifiMacQueue()->GetAc() << " on link "
+                                            << +m_linkId << ": " << backoffEnd.As(Time::US));
+            return WifiExpectedAccessReason::ACCESS_EXPECTED;
+        }
+    }
+
+    NS_LOG_DEBUG("Access grant not expected for reason: " << reason);
+    return reason;
+}
+
 Time
 ChannelAccessManager::GetNavEnd() const
 {
@@ -799,10 +943,14 @@
 
         if (m_nSlotsLeft > 0)
         {
-            if (const auto slots = m_nSlotsLeft * GetSlot(); expectedBackoffDelay > slots)
+            const auto expectedNotifyTime =
+                Max(expectedBackoffEnd - m_nSlotsLeft * GetSlot(),
+                    accessGrantStart - GetSifs() + m_nSlotsLeftMinDelay);
+
+            if (expectedNotifyTime > now)
             {
-                // make the timer expire when the specified number of slots are left
-                expectedBackoffDelay -= slots;
+                // make the timer expire when it's time to notify that the given slots are left
+                expectedBackoffDelay = expectedNotifyTime - now;
             }
             else
             {
@@ -932,13 +1080,14 @@
 }
 
 void
-ChannelAccessManager::NotifyRxEndErrorNow()
+ChannelAccessManager::NotifyRxEndErrorNow(const WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this);
     NS_LOG_DEBUG("rx end error");
     // we expect the PHY to notify us of the start of a CCA busy period, if needed
     m_lastRx.end = Simulator::Now();
     m_lastRxReceivedOk = false;
+    m_eifsNoDifs = m_phy->GetSifs() + GetEstimatedAckTxTime(txVector);
 }
 
 void
@@ -1070,6 +1219,7 @@
     m_lastNavEnd = std::min(m_lastNavEnd, now);
     m_lastAckTimeoutEnd = std::min(m_lastAckTimeoutEnd, now);
     m_lastCtsTimeoutEnd = std::min(m_lastCtsTimeoutEnd, now);
+    m_lastNoPhy.end = std::min(m_lastNoPhy.end, now);
 
     InitLastBusyStructs();
 }
@@ -1105,7 +1255,6 @@
 ChannelAccessManager::NotifySleepNow()
 {
     NS_LOG_FUNCTION(this);
-    m_sleeping = true;
     // Reset backoffs
     ResetAllBackoffs();
     m_feManager->NotifySleepNow();
@@ -1119,7 +1268,6 @@
 ChannelAccessManager::NotifyOffNow()
 {
     NS_LOG_FUNCTION(this);
-    m_off = true;
     // Cancel timeout
     if (m_accessTimeout.IsPending())
     {
@@ -1137,7 +1285,7 @@
 ChannelAccessManager::NotifyWakeupNow()
 {
     NS_LOG_FUNCTION(this);
-    m_sleeping = false;
+    m_lastSleepEnd = Simulator::Now();
     for (auto txop : m_txops)
     {
         ResetBackoff(txop);
@@ -1149,7 +1297,7 @@
 ChannelAccessManager::NotifyOnNow()
 {
     NS_LOG_FUNCTION(this);
-    m_off = false;
+    m_lastOffEnd = Simulator::Now();
     for (auto txop : m_txops)
     {
         ResetBackoff(txop);
@@ -1225,7 +1373,12 @@
 ChannelAccessManager::UpdateLastIdlePeriod()
 {
     NS_LOG_FUNCTION(this);
-    Time idleStart = std::max({m_lastTxEnd, m_lastRx.end, m_lastSwitchingEnd});
+    Time idleStart = std::max({m_lastTxEnd,
+                               m_lastRx.end,
+                               m_lastSwitchingEnd,
+                               m_lastNoPhy.end,
+                               m_lastSleepEnd,
+                               m_lastOffEnd});
     Time now = Simulator::Now();
 
     if (idleStart >= now)
@@ -1248,4 +1401,43 @@
     }
 }
 
+std::ostream&
+operator<<(std::ostream& os, const WifiExpectedAccessReason& reason)
+{
+    switch (reason)
+    {
+    case WifiExpectedAccessReason::ACCESS_EXPECTED:
+        return (os << "ACCESS EXPECTED");
+    case WifiExpectedAccessReason::NOT_REQUESTED:
+        return (os << "NOT_REQUESTED");
+    case WifiExpectedAccessReason::NOTHING_TO_TX:
+        return (os << "NOTHING_TO_TX");
+    case WifiExpectedAccessReason::RX_END:
+        return (os << "RX_END");
+    case WifiExpectedAccessReason::BUSY_END:
+        return (os << "BUSY_END");
+    case WifiExpectedAccessReason::TX_END:
+        return (os << "TX_END");
+    case WifiExpectedAccessReason::NAV_END:
+        return (os << "NAV_END");
+    case WifiExpectedAccessReason::ACK_TIMER_END:
+        return (os << "ACK_TIMER_END");
+    case WifiExpectedAccessReason::CTS_TIMER_END:
+        return (os << "CTS_TIMER_END");
+    case WifiExpectedAccessReason::SWITCHING_END:
+        return (os << "SWITCHING_END");
+    case WifiExpectedAccessReason::NO_PHY_END:
+        return (os << "NO_PHY_END");
+    case WifiExpectedAccessReason::SLEEP_END:
+        return (os << "SLEEP_END");
+    case WifiExpectedAccessReason::OFF_END:
+        return (os << "OFF_END");
+    case WifiExpectedAccessReason::BACKOFF_END:
+        return (os << "BACKOFF_END");
+    default:
+        NS_ABORT_MSG("Unknown expected access reason");
+        return (os << "Unknown");
+    }
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/channel-access-manager.h ns-3.45/src/wifi/model/channel-access-manager.h
--- ns-3.44/src/wifi/model/channel-access-manager.h	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/channel-access-manager.h	2025-06-01 20:34:45.612702100 -0700
@@ -33,9 +33,34 @@
 class PhyListener;
 class Txop;
 class FrameExchangeManager;
+class WifiTxVector;
 enum AcIndex : uint8_t; // opaque enum declaration
 
 /**
+ * @brief Enumeration values for the outcome of the check whether channel access is expected to be
+ *        gained within a given time interval
+ * @see ChannelAccessManager::GetExpectedAccessWithin
+ * @ingroup wifi
+ */
+enum class WifiExpectedAccessReason : uint8_t
+{
+    ACCESS_EXPECTED = 0,
+    NOT_REQUESTED,
+    NOTHING_TO_TX,
+    RX_END,
+    BUSY_END,
+    TX_END,
+    NAV_END,
+    ACK_TIMER_END,
+    CTS_TIMER_END,
+    SWITCHING_END,
+    NO_PHY_END,
+    SLEEP_END,
+    OFF_END,
+    BACKOFF_END
+};
+
+/**
  * @brief Manage a set of ns3::Txop
  * @ingroup wifi
  *
@@ -171,6 +196,21 @@
     Time GetBackoffEndFor(Ptr<Txop> txop) const;
 
     /**
+     * Check whether channel access is expected to be granted within the given delay. If it is,
+     * ACCESS_EXPECTED is returned. If channel access is not expected to be granted because no
+     * AC has requested channel access, NOT_REQUESTED is returned. If no AC has frames to send,
+     * NOTHING_TO_TX is returned. If any of the times returned by DoGetAccessGrantStart() exceeds
+     * the given deadline, the reason corresponding to the earliest of such times is returned.
+     * Otherwise, it means that access cannot be granted in time due to the backoff slots to wait
+     * and BACKOFF_END is returned.
+     *
+     * @see DoGetAccessGrantStart
+     * @param delay the given delay
+     * @return ACCESS_EXPECTED or the reason why channel access is not expected to be gained in time
+     */
+    WifiExpectedAccessReason GetExpectedAccessWithin(const Time& delay) const;
+
+    /**
      * @return the time until the NAV has been set
      */
     Time GetNavEnd() const;
@@ -236,8 +276,10 @@
     /**
      * Notify the Txop that a packet reception was just
      * completed unsuccessfuly.
+     *
+     * @param txVector the TXVECTOR used for transmission
      */
-    void NotifyRxEndErrorNow();
+    void NotifyRxEndErrorNow(const WifiTxVector& txVector);
     /**
      * @param duration expected duration of transmission
      *
@@ -408,6 +450,20 @@
     Time GetBackoffEndFor(Ptr<Txop> txop, Time accessGrantStart) const;
 
     /**
+     * Return a map containing (Time, WifiExpectedAccessReason) pairs sorted in increasing order
+     * of times. For each of the events preventing channel access (e.g., medium busy, RX state,
+     * TX state, etc), a pair is present in the map indicating the latest known time for which
+     * channel access cannot be granted due to that event. Therefore, the returned map does not
+     * contain a pair for some WifiExpectedAccessReason enum values (ACCESS_EXPECTED, NOTHING_TO_TX,
+     * NOT_REQUESTED and BACKOFF_END).
+     *
+     * @param ignoreNav whether NAV should be ignored
+     * @return a map containing (Time, WifiExpectedAccessReason) pairs sorted in increasing order
+     *         of times
+     */
+    std::multimap<Time, WifiExpectedAccessReason> DoGetAccessGrantStart(bool ignoreNav) const;
+
+    /**
      * This method determines whether the medium has been idle during a period (of
      * non-null duration) immediately preceding the time this method is called. If
      * so, the last idle start time and end time for each channel type are updated.
@@ -480,9 +536,12 @@
     std::map<WifiChannelListType, Timespan>
         m_lastIdle;               //!< the last idle start and end time for each channel type
     Time m_lastSwitchingEnd;      //!< the last switching end time
-    bool m_sleeping;              //!< flag whether it is in sleeping state
-    bool m_off;                   //!< flag whether it is in off state
+    Time m_lastSleepEnd;          //!< the last sleep end time
+    Time m_lastOffEnd;            //!< the last off end time
     Time m_eifsNoDifs;            //!< EIFS no DIFS time
+    Timespan m_lastNoPhy;         //!< the last start and end time no PHY was operating on the link
+    mutable Time m_cachedSifs;    //!< cached value for SIFS, to be only used without a PHY
+    mutable Time m_cachedSlot;    //!< cached value for slot, to be only used without a PHY
     EventId m_accessTimeout;      //!< the access timeout ID
     bool m_generateBackoffOnNoTx; //!< whether the backoff should be invoked when the AC gains the
                                   //!< right to start a TXOP but it does not transmit any frame
@@ -490,6 +549,8 @@
                                   //!< provided that the queue is not actually empty
     bool m_proactiveBackoff; //!< whether a new backoff value is generated when a CCA busy period
                              //!< starts and the backoff counter is zero
+    Time m_resetBackoffThreshold; //!< if no PHY operates on a link for a period greater than this
+                                  //!< threshold, the backoff on that link is reset
 
     /// Information associated with each PHY that is going to operate on another EMLSR link
     struct EmlsrLinkSwitchInfo
@@ -511,6 +572,11 @@
     uint8_t m_nSlotsLeft;                  //!< fire the NSlotsLeftAlert trace source when the
                                            //!< backoff counter with the minimum value among all
                                            //!< ACs reaches this value
+    Time m_nSlotsLeftMinDelay; //!< the minimum gap between the end of a medium busy event and
+                               //!< the time the NSlotsLeftAlert trace source can be fired
+
+    /// default value for the NSlotsLeftMinDelay attribute, corresponds to a PIFS in 5GHz/6GHz bands
+    static const Time DEFAULT_N_SLOTS_LEFT_MIN_DELAY;
 
     /**
      * TracedCallback signature for NSlotsLeft alerts.
@@ -527,6 +593,15 @@
     NSlotsLeftTracedCallback m_nSlotsLeftCallback; //!< traced callback for NSlotsLeft alerts
 };
 
+/**
+ * @brief Stream insertion operator.
+ *
+ * @param os the stream
+ * @param reason the expected access reason
+ * @return a reference to the stream
+ */
+std::ostream& operator<<(std::ostream& os, const WifiExpectedAccessReason& reason);
+
 } // namespace ns3
 
 #endif /* CHANNEL_ACCESS_MANAGER_H */
